
#include <time.h>
#include "now.h"

long diff_seconds(struct tm*, struct tm*);

static struct tm mark_time;


void sec_timer_reset()
{
   time_t time_now;

   
   time(&time_now);

   mark_time = *(localtime(&time_now));
}



long sec_timer_elapsed()
{
   time_t time_now;

   struct tm time_now_struct;


   time(&time_now);

   time_now_struct = *(localtime(&time_now));

   return (diff_seconds(&time_now_struct, &mark_time));

}

 
long diff_seconds(struct tm *later, struct tm *earlier)
{

   struct tm result;

   long working_seconds;


   if (   ((*later).tm_yday == (*earlier).tm_yday)
       && ((*later).tm_hour == (*earlier).tm_hour)
       && ((*later).tm_min  == (*earlier).tm_min)  )

            return ((*later).tm_sec - (*earlier).tm_sec);

   working_seconds = (*later).tm_sec + (60 - (*earlier).tm_sec);



   if (   ((*later).tm_yday == (*earlier).tm_yday)
       && ((*later).tm_hour == (*earlier).tm_hour) )
          
          return (working_seconds + 
                ( ( ((*later).tm_min - (*earlier).tm_min) - 1 ) * 60));
   
	  

   working_seconds = working_seconds + (((*later).tm_min + 
                                        (59 - (*earlier).tm_min)) * 60);

   if ((*later).tm_yday == (*earlier).tm_yday)

            return (working_seconds + ((((*later).tm_hour - (*earlier).tm_hour)
                                                                 - 1) * 3600));

   working_seconds = working_seconds + (((*later).tm_hour + 
                                        (23 - (*earlier).tm_hour)) * 3600);

   if ((*later).tm_year == (*earlier).tm_year)

            return (working_seconds + ((((*later).tm_yday - (*earlier).tm_yday)
                                                           - 1) * 3600 * 24));

   return (working_seconds + (((*later).tm_yday + (364 - (*earlier).tm_yday))
                                                            * 3600 * 24));


}


#ifdef TEST_SEC_TIMER

#include "timer.h"
#include "now.h"

main()
{

   struct tm old, new;

   long got, expected;

   long converted_seconds, actual_seconds;

   int loop_cnt;


   old.tm_sec = 15;

   old.tm_min = 50;

   old.tm_hour = 14;

   old.tm_year = 94;

   old.tm_yday = 360;



   new.tm_sec = 35;

   new.tm_min = 50;

   new.tm_hour = 14;

   new.tm_year = 94;

   new.tm_yday = 360;


   printf("\nConversion tests\n\n");
   printf("Expected 20  received %d\n",diff_seconds(&new,&old));



   new.tm_sec = 35;

   new.tm_min = 52;

   new.tm_hour = 14;

   new.tm_year = 94;

   new.tm_yday = 360;


   printf("Expected 140  received %d\n",diff_seconds(&new,&old));



   new.tm_sec = 35;

   new.tm_min = 52;

   new.tm_hour = 18;

   new.tm_year = 94;

   new.tm_yday = 360;


   printf("Expected %d  received %d\n",(140 + (4 * 3600)),
          diff_seconds(&new,&old));




   new.tm_sec = 35;

   new.tm_min = 52;

   new.tm_hour = 18;

   new.tm_year = 94;

   new.tm_yday = 363;


   printf("Expected %d  received %d\n",(140 + (4 * 3600) + (3 * 3600 * 24)),
          diff_seconds(&new,&old));




   new.tm_sec = 35;

   new.tm_min = 52;

   new.tm_hour = 18;

   new.tm_year = 95;

   new.tm_yday = 3;


   printf("Expected %d  received %d\n",(140 + (4 * 3600) + (8 * 3600 * 24)),
          diff_seconds(&new,&old));


   printf("\nTiming Tests\n\n");

   timer_reset();

   sec_timer_reset();

   sleep(5);

   converted_seconds = timer_elapsed() / 1000;

   printf("Expected 5  Got %d from timer and %d from sec_timer\n",
          converted_seconds, sec_timer_elapsed());

   actual_seconds = converted_seconds;

   for (loop_cnt = 1; loop_cnt < 72; loop_cnt++)
     {
      sleep(600);

      actual_seconds+=600;

      converted_seconds = timer_elapsed() / 1000;

      printf("Expected %d  Got %d from timer and %d from sec_timer at ",
             actual_seconds, converted_seconds, sec_timer_elapsed());

      now(stdout);
     }
}

#endif






